import json

from django import http
from django.core.serializers import serialize, deserialize
from django.http import JsonResponse, HttpResponse
from datetime import datetime

from django.views.decorators.csrf import ensure_csrf_cookie

from web.models import Article


@ensure_csrf_cookie
def echo_view(request, *args, **kwargs):
    answer = {
        'time': datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
        'method': request.method,
    }
    
    print(request.body)

    if request.method == 'POST':
        if request.body:
            answer['content'] = json.loads(request.body)
    
    return JsonResponse(answer)


def articles_view(request, *args, **kwargs):
    if request.method == 'GET':
        qs = Article.objects.values()
        return JsonResponse(list(qs), safe=False)

    elif request.method == 'POST':

        if request.body:
            try:
                article = Article.objects.create(**json.loads(request.body))
            except TypeError:
                return http.HttpResponseBadRequest('invalid request body')

            return JsonResponse({'id': article.id, 'title': article.title, 'text': article.text})

        else:
            return JsonResponse(status=400, data={'error': 'No data provided!'})
